﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using Syncfusion.UI.Xaml.ScrollAxis;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Media;

namespace SfDataGridWithStackedHeaders
{
   public class GridCustomStackedRenderer : GridVirtualizingCellRenderer<GridStackedHeaderCellControl, GridStackedHeaderCellControl>
    {
        public GridCustomStackedRenderer()
        {
            SupportsRenderOptimization = false;
            this.UseOnlyRendererElement = true;
        }
        public override void OnInitializeEditElement(Syncfusion.UI.Xaml.ScrollAxis.RowColumnIndex rowColumnIndex, GridStackedHeaderCellControl uiElement, GridColumn column, object dataContext)
        {
            var bind = new Binding { Path = new PropertyPath("HeaderText"), Mode = BindingMode.TwoWay };
            uiElement.SetBinding(ContentControl.ContentProperty, bind);
            /*if (rowColumnIndex.ColumnIndex == 0)
                uiElement.Background = new SolidColorBrush(Windows.UI.Colors.RosyBrown);
            if (rowColumnIndex.ColumnIndex == 3)
                uiElement.Background = new SolidColorBrush(Windows.UI.Colors.BlanchedAlmond);
            if (rowColumnIndex.ColumnIndex == 5)
                uiElement.Background = new SolidColorBrush(Windows.UI.Colors.BlueViolet);*/
            uiElement.DataContext = dataContext;
           
        }
        public override void OnUpdateEditBinding(Syncfusion.UI.Xaml.ScrollAxis.RowColumnIndex cellRowcolumnIndex, GridStackedHeaderCellControl element, GridColumn column, object dataContext)
        {
            element.ClearValue(GridStackedHeaderCellControl.ContentProperty);
               var bind = new Binding { Path = new PropertyPath("HeaderText"), Mode = BindingMode.TwoWay };
               element.SetBinding(GridHeaderCellControl.ContentProperty, bind);
              
        }
       
    }
}
