﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Syncfusion.UI.Xaml.Grid;


namespace SfDataGridWithStackedHeaders.CustomClass
{
   public    class GridRowCustomStyleSelector : StyleSelector
   {
      protected override Style SelectStyleCore(object rowElement, DependencyObject container)
      {

         var row = rowElement as DataRowBase;
         var item = row.RowData as Student;

         if (item != null && item.ID == 1001)
         {
            if (row.RowIndex % 2 != 0)
               return Application.Current.Resources["RedRowStyle"] as Style;
            return Application.Current.Resources["RedAlternatingRowStyle"] as Style;
         }

         // Applying alternating background for rows.
         if (row.RowIndex % 2 != 0)
            return Application.Current.Resources["RowStyle"] as Style;
         return Application.Current.Resources["AlternatingRowStyle"] as Style;
      }
   }
}
