﻿using System.Collections;
using System.Reflection;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Media.Imaging;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Syncfusion.UI.Xaml.Controls.Input;
using Syncfusion.UI.Xaml.Grid.Cells;
using Syncfusion.UI.Xaml.ScrollAxis;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SfDataGridWithStackedHeaders
{
   /// <summary>
   /// An empty page that can be used on its own or navigated to within a Frame.
   /// </summary>
   public sealed partial class MainPage : Page
   {
      private int rowsCounter = 1;

      public MainPage()
      {
         this.InitializeComponent();
         this.datagrid.DataContext = this;
         ItemSource1 = GetData();
         this.datagrid.ItemsSource = ItemSource1;
         

         datagrid.GridColumnSizer.SortIconWidth = 60;
         this.DataContext = new PageViewModel();
         datagrid.SelectionController = new GridSelectionControllerExtension(datagrid);
         datagrid.CellRenderers.Remove("Numeric");
         datagrid.CellRenderers.Add("Numeric", new GridCustomCellNumericRenderer());
         datagrid.CellRenderers.Remove("ComboBox");
         datagrid.CellRenderers.Add("ComboBox", new GridCustomComboBoxRenderer());
      }


      public ObservableCollection<Student> GetData(int maxCount = 10)
      {
         ObservableCollection<Student> orderinfo = new ObservableCollection<Student>();

         for (int i = 0; i < maxCount; i++)
         {
            Student st = new Student();
            st.ID = 1000 + i;
            st.Name = "Robert";
            st.SubjectList = new List<Subject>();
            st.SubjectList.Add(new Subject() {Score = 85, SubjectType = "Type 1"});
            st.SubjectList.Add(new Subject() {Score = 94, SubjectType = "Type 1"});
            st.SubjectList.Add(new Subject() {Score = 43, SubjectType = "Type 2"});
            st.SubjectList.Add(new Subject() {Score = 43, SubjectType = "Type 2"});
            orderinfo.Add(st);

            Student st1 = new Student();
            st1.ID = 1000 + 2;
            st1.Name = "David";
            st1.Score = (new Random()).Next(50, 100);
            st1.SubjectList = new List<Subject>();
            st1.SubjectList.Add(new Subject() {Score = 65, SubjectType = "Type 1"});
            st1.SubjectList.Add(new Subject() {Score = 34, SubjectType = "Type 1"});
            st1.SubjectList.Add(new Subject() {Score = 33, SubjectType = "Type 2"});
            st1.SubjectList.Add(new Subject() {Score = 75, SubjectType = "Type 2"});
            orderinfo.Add(st1);

            Student st2 = new Student();
            st2.ID = 1000 + i;
            st2.Name = "Albert";
            st2.SubjectList = new List<Subject>();
            st2.SubjectList.Add(new Subject() {Score = 56, SubjectType = "Type 1"});
            st2.SubjectList.Add(new Subject() {Score = 15, SubjectType = "Type 1"});
            st2.SubjectList.Add(new Subject() {Score = 79, SubjectType = "Type 2"});
            st2.SubjectList.Add(new Subject() {Score = 19, SubjectType = "Type 2"});
            orderinfo.Add(st2);

            Student st3 = new Student();
            st3.ID = 1000 + i;
            st3.Name = "Stepen";
            st3.Score = (new Random()).Next(1, 49);
            st3.SubjectList = new List<Subject>();
            st3.SubjectList.Add(new Subject() {Score = 10, SubjectType = "Type 1"});
            st3.SubjectList.Add(new Subject() {Score = 12, SubjectType = "Type 1"});
            st3.SubjectList.Add(new Subject() {Score = 17, SubjectType = "Type 2"});
            st3.SubjectList.Add(new Subject() {Score = 13, SubjectType = "Type 2"});
            orderinfo.Add(st3);

            Student st4 = new Student();
            st4.ID = 1000 + i;
            st4.Name = "Iman";
            st4.SubjectList = new List<Subject>();
            st4.SubjectList.Add(new Subject() {Score = 83, SubjectType = "Type 1"});
            st4.SubjectList.Add(new Subject() {Score = 60, SubjectType = "Type 1"});
            st4.SubjectList.Add(new Subject() {Score = 72, SubjectType = "Type 2"});
            st4.SubjectList.Add(new Subject() {Score = 92, SubjectType = "Type 2"});
            orderinfo.Add(st4);

            Student st5 = new Student();
            st5.ID = 1000 + i;
            st5.Name = "Simson";
            st5.SubjectList = new List<Subject>();
            st5.SubjectList.Add(new Subject() {Score = 20, SubjectType = "Type 1"});
            st5.SubjectList.Add(new Subject() {Score = 88, SubjectType = "Type 1"});
            st5.SubjectList.Add(new Subject() {Score = 90, SubjectType = "Type 2"});
            st5.SubjectList.Add(new Subject() {Score = 80, SubjectType = "Type 2"});
            orderinfo.Add(st5);
         }

         return orderinfo;
      }

      private ObservableCollection<Student> _itemsource;

      public ObservableCollection<Student> ItemSource1
      {
         get { return _itemsource; }
         set
         {
            _itemsource = value;
            OnPropertyChanged("ItemSource1");
         }
      }

      #region INotifyPropertyChanged Members

      public event PropertyChangedEventHandler PropertyChanged;

      private void OnPropertyChanged(string propertyName)
      {
         if (PropertyChanged != null)
            PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
      }

      #endregion


      /// <summary>
      /// Invoked when this page is about to be displayed in a Frame.
      /// </summary>
      /// <param name="e">Event data that describes how this page was reached.  The Parameter
      /// property is typically used to configure the page.</param>
      protected override void OnNavigatedTo(NavigationEventArgs e)
      {
      }

      private void Datagrid_OnCurrentCellValidating(object sender, CurrentCellValidatingEventArgs args)
      {
         //const int minValue = 1;
         //const int maxValue = 100;

         //int intAnswer;
         //if (args.NewValue != null && int.TryParse(args.NewValue.ToString(), out intAnswer))
         //{
         //   if (intAnswer < minValue || intAnswer > maxValue)
         //   {
         //      args.ErrorMessage = string.Format("Please enter a number from {0} to {1}.", minValue, maxValue);
         //      args.IsValid = false;
         //   }
         //}

      }

      private void UIElement_OnTapped(object sender, TappedRoutedEventArgs e)
      {
         var newItemSource1 = GetData(20);
         ItemSource1.Clear();
         foreach (var student in newItemSource1)
         {
            ItemSource1.Add(student);
         }
         datagrid.AutoScroller.VScrollBar.Value = 0;
         datagrid.AutoScroller.HScrollBar.Value = 0;
      }

      private void Datagrid_OnCurrentCellRequestNavigate(object sender, CurrentCellRequestNavigateEventArgs args)
      {
         var pageModel = this.DataContext as PageViewModel;
         var student = args.RowData as Student;
         pageModel.Score = student.Score;
      }

      private void SfNumericUpDown_OnValueChanged(object sender, ValueChangedEventArgs e)
      {
         var pageModel = this.DataContext as PageViewModel;
         pageModel.NewScore = pageModel.Score;
         if (e.NewValue != null)
         {
            int newValue;
            int.TryParse(e.NewValue.ToString(), out newValue);
            pageModel.ActualNewScore = newValue;
         }
         else
            pageModel.ActualNewScore = null;
      }
   }

   public class GridCustomCellImageRenderer : GridCellImageRenderer
   {
      public override void OnInitializeEditElement(Syncfusion.UI.Xaml.ScrollAxis.RowColumnIndex rowColumnIndex, Windows.UI.Xaml.Controls.Image uiElement, Syncfusion.UI.Xaml.Grid.GridColumn column, object dataContext)
      {
         uiElement.CacheMode = new BitmapCache();

         base.OnInitializeEditElement(rowColumnIndex, uiElement, column, dataContext);
      }
   }

   public class GridCustomCellNumericRenderer : GridCellNumericRenderer
   {
      private const int MaxLength = 3;
      public override void OnInitializeEditElement(RowColumnIndex rowColumnIndex, SfNumericTextBox uiElement, GridColumn column, object dataContext)
      {
         uiElement.MaxLength = MaxLength;
         var inputScope = new InputScope();
         inputScope.Names.Add(new InputScopeName(InputScopeNameValue.Number));
         uiElement.InputScope = inputScope;
         base.OnInitializeEditElement(rowColumnIndex, uiElement, column, dataContext);
      }
   }


   public class GridSelectionControllerExtension : GridSelectionController
   {
      public GridSelectionControllerExtension(SfDataGrid dataGrid)
         : base(dataGrid)
      {
      }

      protected override void ProcessPointerPressed(PointerRoutedEventArgs args, RowColumnIndex rowColumnIndex)
      {
         base.ProcessPointerPressed(args, rowColumnIndex);
         if (this.CurrentCellManager.HasCurrentCell && this.CurrentCellManager.CurrentCell.IsEditing)
         {
            var propInfo = this.CurrentCellManager.CurrentCell.GetType().GetRuntimeFields();
            var renderer = this.CurrentCellManager.CurrentCell.Renderer as GridCellRendererBase;
            Control ColumnElement = renderer.CurrentCellRendererElement as Control;
            ColumnElement.Focus(FocusState.Programmatic);
         }
      }
   }
   public class BooleanToImageConverter : IValueConverter
   {
      public object Convert(object value, Type targetType, object parameter, string language)
      {
         bool? visible = value as bool?;
         string imagePath = parameter as string;

         if (visible.HasValue && visible.Value && !String.IsNullOrEmpty(imagePath))
         {
            Uri uri = new Uri(imagePath);
            BitmapImage image = new BitmapImage(uri);
            return image;
         }
         return null;
      }

      public object ConvertBack(object value, Type targetType, object parameter, string language)
      {
         throw new NotImplementedException();
      }
   }

   public class NullableValueConverter : IValueConverter
   {
      public object Convert(object value, Type targetType, object parameter, string language)
      {
         return value == null ? null : value.ToString();
      }

      public object ConvertBack(object value, Type targetType, object parameter, string language)
      {
        if (value != null)
         {
            string s = value.ToString();
            int result;
            if (!string.IsNullOrWhiteSpace(s) && int.TryParse(s, out result))
            {
               return result;
            }
         }

         return null;
      }

   }

   public class MCOption
   {
      public int ID { get; set; }
      public int Text { get; set; }
   }

   public class MCOptions : List<MCOption>
   {
      
   }

   public class GridCustomComboBoxRenderer : GridCellComboBoxRenderer
   {
      protected override void OnEditElementLoaded(object sender, Windows.UI.Xaml.RoutedEventArgs e)
      {
         (sender as ComboBox).IsDropDownOpen = true;
         base.OnEditElementLoaded(sender, e);
      }
   }

}
