﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGridWithStackedHeaders
{
   public class PageViewModel : INotifyPropertyChanged
   {
      private int? score;
      private int? newScore;
      private int? actualNewScore;
      private int _ComboBox;

      public int? Score
      {
         get
         {
            return score;
         }
         set
         {
            score = value;
            OnPropertyChanged("Score");
         }
      }

      public int ComboBox
      {
         get
         {
            return _ComboBox;
         }
         set
         {
            _ComboBox = value;
            OnPropertyChanged("ComboBox");
         }
      }

      public int? NewScore
      {
         get
         {
            return newScore;
         }
         set
         {
            newScore = value;
            OnPropertyChanged("NewScore");
         }
      }

      public int? ActualNewScore
      {
         get
         {
            return actualNewScore;
         }
         set
         {
            actualNewScore = value;
            OnPropertyChanged("ActualNewScore");
         }
      }


      #region INotifyPropertyChanged Members

      public event PropertyChangedEventHandler PropertyChanged;

      private void OnPropertyChanged(string propertyName)
      {
         if (PropertyChanged != null)
            PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
      }

      #endregion

   }

   public class Student : INotifyPropertyChanged
    {
        private int id;
        private string name;
         private int? score;
        private List<Subject> sl;

        public int ID
        {
            get
            {
                return id;
            }
            set
            {
                id = value;
                OnPropertyChanged("CompanyName");
            }
        }

        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
                OnPropertyChanged("Name");
            }
        }

        public int? Score
        {
           get
           {
              return score;
           }
           set
           {
              score = value;
              OnPropertyChanged("Score");
           }
        }

        public bool GoodScore
      {
           get { return Score > 40; }
      }

        public List<Subject> SubjectList
        {
            get
            {
                return sl;
            }
            set
            {
                sl = value;
                OnPropertyChanged("SubjectList");
            }

        }
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
        
    }

    public class Subject : INotifyPropertyChanged
    {

        private int subjectname;
        public int SubjectName
        {
            get
            {
                return subjectname;
            }
            set
            {
                subjectname = value;
                OnPropertyChanged("SubjectName");
            }
        }

        private int sname;
        public int Score
        {
            get
            {
                return sname;
            }
            set
            {
                sname = value;
                OnPropertyChanged("SubjectName");
            }
        }

        private string subjectType;
        public string SubjectType
        {
            get
            {
                return subjectType;
            }
            set
            {
                subjectType = value;
                OnPropertyChanged("SubjectType");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
